.486                      ; create 32 bit code
.model flat, stdcall      ; 32 bit memory model
option casemap :none      ; case sensitive

include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\macros\macros.asm

includelib \masm32\lib\masm32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

GPPHDR_VER=10h ;  -    0x10,   

winampGeneralPurposePlugin STRUCT ;,      
  version dd ?             ; version of the plugin, defined in "gen_empty.h"
  description dd ?         ; name/title of the plugin, defined in "gen_empty.h"
  init dd ?                ; function which will be executed on init event
  config dd ?              ; function which will be executed on config event
  quit dd ?                ; function which will be executed on quit event
  hwndParent dd ?          ; (?)
  hDllInstance dd ?        ; (?)
winampGeneralPurposePlugin ENDS

.data ;  -  
  plugin_name db "Test Plugin",0 ;  -       
  ;     -  0x10,   ,
  ;      (     ),
  ;  ,     ,
  ;  ,    .
  ;   ,    - hWnd    dllInstance.

  plugin winampGeneralPurposePlugin {GPPHDR_VER,offset plugin_name,offset init,offset config,offset quit,0,0}

.code

LibMain proc instance:DWORD,reason:DWORD,reserved:DWORD ;,    dll
  .if reason == DLL_PROCESS_ATTACH
    mov eax,1 ; 1   dll
  .endif
ret
LibMain ENDP

;     -               
winampGetGeneralPurposePlugin PROC
  mov eax,offset plugin ;  
ret
winampGetGeneralPurposePlugin ENDP

config PROC ;    
  invoke MessageBox,0,chr$("   ."),offset plugin_name,0
  xor eax,eax
ret
config ENDP

init PROC ;   
  invoke MessageBox,0,chr$(" ."),offset plugin_name,0
  xor eax,eax
ret
init ENDP

quit PROC ;   
  invoke MessageBox,0,chr$(" ."),offset plugin_name,0
  xor eax,eax
ret
quit ENDP

end LibMain ; ,     dll - LibMain